module SalesforceConnect
	class User

		def all
			users = []
			result = SalesforceConnect.client.query('select FirstName, LastName, Email, CompanyName, Title, Phone from User').to_a

			result.each do |user|
				users << {
					name: user[:FirstName],
					last_name: user[:LastName],
					email: user[:Email],
					company: user[:CompanyName],
					job_title: user[:Title],
					phone: user[:Phone]
				}
			end

			users
		end

		def find(field, value)
			SalesforceConnect.client.find('User', value, field)
		end

		def select(field, value)
			SalesforceConnect.client.select('User', value, [*field])
		end

		def create(user)
			salesforce_hash = {
				FirstName: user[:name],
				LastName: user[:last_name],
				Email: user[:email],
				CompanyName: user[:company],
				Title: user[:job_title],
				Phone: user[:phone],
				# Site: user[:website],
				Alias: (user[:last_name] + user[:name])[0..7],
				ProfileId: '00eo0000000om9WAAQ',
				Username: user[:last_name] + user[:email],
				CommunityNickname: user[:email],
				TimeZoneSidKey: 'America/Sao_Paulo',
				LocaleSidKey: 'pt_BR',
				EmailEncodingKey: 'ISO-8859-1',
				LanguageLocaleKey: 'pt_BR',
			}

			SalesforceConnect.client.create!('User', salesforce_hash)
		end

		def update(user)
			# Finish
		end

		def upsert(user)
			# Finish
		end

		def destroy(id)
			# Finish
		end
	end
end